(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/scripts/Test.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, '82e0dUtV6hFq6NVyicjLsm8', 'Test', __filename);
// scripts/Test.ts

Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Test = /** @class */ (function (_super) {
    __extends(Test, _super);
    function Test() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.bgNode = null;
        _this.particleNode = null;
        _this.progressBar = null;
        _this.progressBar2 = null;
        _this.progress = 0;
        return _this;
    }
    Test.prototype.start = function () {
        var node = this.progressBar.node;
        this.params = {};
        this.params.R = Math.sqrt(node.width / 2 * node.width / 2 + node.height / 2 * node.height / 2);
        this.params.x1 = node.position.x - node.width * node.anchorX;
        this.params.x2 = node.position.x + node.width * (1 - node.anchorX);
        this.params.y1 = node.position.y - node.height * node.anchorY;
        this.params.y2 = node.position.y + node.height * (1 - node.anchorY);
        this.params.width = node.width;
        this.params.height = node.height;
    };
    Test.prototype.update = function (dt) {
        if (!this.params)
            return;
        var a = this.progress++ % 360;
        // 设置进度条
        var progress = a / 360;
        var radians = a * (Math.PI / 180);
        this.progressBar.progress = progress;
        this.progressBar2.progress = progress;
        var node = this.progressBar.node;
        // 斜边
        var AB = this.params.R;
        // 对边
        var AC = Math.sin(radians) * AB;
        // 临边
        var BC = Math.cos(radians) * AB;
        // 求出在四边形上的斜边长度AB后，求出粒子在四边形的坐标
        if (Math.abs(AC) >= this.params.height / 2) { // 将对应区域(上下两条边)坐标限制在四边形上，注释掉后对应区域会出现圆弧形轨迹
            AC = this.params.height / 2;
            AB = AC / Math.sin(radians);
        }
        if (Math.abs(BC) >= this.params.width / 2) { // 将对应区域(左右两条边)坐标限制在四边形上，注释掉后对应区域会出现圆弧形轨迹
            BC = this.params.width / 2;
            AB = BC / Math.cos(radians);
        }
        AB = Math.abs(AB);
        // 求出 x y 坐标
        var x = node.position.x + AB * Math.cos(radians);
        var y = node.position.y + AB * Math.sin(radians);
        // 设置粒子坐标
        this.particleNode.position = cc.v2(x, y);
    };
    __decorate([
        property(cc.Node)
    ], Test.prototype, "bgNode", void 0);
    __decorate([
        property(cc.Node)
    ], Test.prototype, "particleNode", void 0);
    __decorate([
        property(cc.ProgressBar)
    ], Test.prototype, "progressBar", void 0);
    __decorate([
        property(cc.ProgressBar)
    ], Test.prototype, "progressBar2", void 0);
    Test = __decorate([
        ccclass
    ], Test);
    return Test;
}(cc.Component));
exports.default = Test;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=Test.js.map
        